package com.example.weatherapp;

import android.os.Bundle;
import android.view.LayoutInflater;
import android.view.Menu;
import android.view.MenuItem;
import android.view.View;
import android.view.ViewGroup;

import androidx.annotation.NonNull;
import androidx.fragment.app.Fragment;
import androidx.navigation.fragment.NavHostFragment;

import java.util.*;
import android.widget.ArrayAdapter;
import android.widget.ListView;

import com.example.weatherapp.databinding.FragmentSecondBinding;
import android.view.MenuInflater;

import android.view.Menu;
import android.view.MenuItem;
import android.content.Intent;
import android.speech.RecognizerIntent;
import android.app.Activity;
import android.util.Log;



public class SecondFragment extends Fragment {
    private FragmentSecondBinding binding;
    public static ArrayAdapter<String> mForecastAdapter;
    public static String mAnswer;


    @Override
    public View onCreateView(
            LayoutInflater inflater, ViewGroup container,
            Bundle savedInstanceState
    ) {
        setHasOptionsMenu(true);
        String[] data = {
                "Today 3/11 - Sunny - 17 C",
                "Fri 4/11 - Cloudy - 18 C",
                "Sat 5/11 - Rainy - 17 C",
                "Sun 6/11 - Sunny - 19 C",
                "Mon 7/1 - Sunny - 19 C",
                "Tues 8/11 - Rainy - 18 C",
                "Wed 9/11 - TRAPPED  IN WEATHERSTATION - 10 C"
        };
        List<String> weekForecast = new ArrayList<String>(Arrays.asList(data));
        mForecastAdapter = new ArrayAdapter<String>(getActivity(), // The current context (this activity)
                R.layout.list_item_forecast, // The name of the layout ID.
                R.id.list_item_forecast_textview, // The ID of the textview to populate.
                weekForecast);

        binding = FragmentSecondBinding.inflate(inflater, container, false);

        ListView listView = (ListView) binding.listviewForecast;
        listView.setAdapter(mForecastAdapter);
        return binding.getRoot();

    }

    @Override
    public void onCreateOptionsMenu(Menu menu, MenuInflater inflater) {
        // Inflate the menu; this adds items to the action bar if it is present.
        inflater.inflate(R.menu.forecast_update, menu);
    }

    @Override
    public boolean onOptionsItemSelected(MenuItem item) {
        // Handle action bar item clicks here. The action bar will
        // automatically handle clicks on the Home/Up button, so long
        // as you specify a parent activity in AndroidManifest.xml.
        int id = item.getItemId();

        //noinspection SimplifiableIfStatement
        if (id == R.id.action_refresh) {
            FetchWeatherForecast weatherTask = new FetchWeatherForecast();
            weatherTask.execute("0000");
            return true;
        }
        else if (id == R.id.voice_commands){
            startSpeechRecognizer();
            return true;
        }

        return super.onOptionsItemSelected(item);
    }
    private void startSpeechRecognizer() {
        int REQUEST_SPEECH_RECOGNIZER = 3000;
        Intent intent = new Intent  (RecognizerIntent.ACTION_RECOGNIZE_SPEECH);
        intent.putExtra(RecognizerIntent.EXTRA_LANGUAGE_MODEL, "en-US");
        intent.putExtra(RecognizerIntent.EXTRA_PROMPT,"City of Interest?");
        startActivityForResult(intent, REQUEST_SPEECH_RECOGNIZER);
    }

    @Override
    public void onActivityResult(int requestCode, int resultCode,
                                 Intent data) {
        int REQUEST_SPEECH_RECOGNIZER = 3000;
        super.onActivityResult(requestCode, resultCode, data);
        Log.i("DEMO-REQUESTCODE", Integer.toString(requestCode));
        Log.i("DEMO-RESULTCODE", Integer.toString(resultCode));
        if (requestCode == REQUEST_SPEECH_RECOGNIZER && resultCode == Activity.RESULT_OK && data != null){
            ArrayList<String> text = data.getStringArrayListExtra(RecognizerIntent.EXTRA_RESULTS);
            mAnswer = text.get(0);
            Log.i("DEMO-ANSWER", text.get(0));
            FetchWeatherForecast weatherTask = new FetchWeatherForecast();
            double city_lat  = 0;
            double city_long  = 0;
            switch (mAnswer.toLowerCase()){
                case "athens"       : city_lat = 37.98; city_long = 23.73; break;
                case "elefsina"     : city_lat = 38.04; city_long = 23.54; break;
                case "london"       : city_lat = 51.51; city_long =  0.13; break;
                case "paris"        : city_lat = 48.86; city_long =  2.35; break;
                case "αθήνα"        : city_lat = 37.98; city_long = 23.73; break;
                case "ελευσίνα"     : city_lat = 38.04; city_long = 23.54; break;
                case "λονδίνο"      : city_lat = 51.51; city_long =  0.13; break;
                case "παρίσι"       : city_lat = 48.86; city_long =  2.35; break;
                default             : city_lat = 38.04; city_long = 23.54;
            }
            Log.i("LAT",    Double.toString(city_lat));
            Log.i("LONG",   Double.toString(city_long));
            weatherTask.execute(Double.toString(city_lat), Double.toString(city_long));

        }
        else{
            System.out.println("Recognizer API error");
        }
    }




    @Override
    public void onDestroyView() {
        super.onDestroyView();
        binding = null;
    }

}